<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>30.20</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Montserrat:ital@0;1&family=Open+Sans&display=swap"
        rel="stylesheet">
    <style>
        .fame {
            width: 1162px;
            height: 795px;
            top: -1282px;
            left: -1471px;
            padding: 77px 35px 78px 36px;
        }

        .signup {
            justify-content: space-evenly;
            width: 1091px;
            height: 640px;
            top: 77px;
            left: 36px;
        }

        h4 {
            font-family: Open Sans;
            font-size: 20px;
            font-weight: 700;
            line-height: 27px;
            letter-spacing: 0em;
            text-align: left;
            color: #38D39F;
            margin-top: 59px;
        }

        .form-group {
            width: 304px;
            height: 49.05755615234375px;
            top: 286px;
            left: 105px;
            border-radius: 3px;
            border: 1px;
            margin-bottom: 30px;
        }

        .btn {
            margin-top: 20px;
            margin-bottom: 27px;
            width: 304px;
            height: 40px;
            top: 418px;
            left: 105px;
            border-radius: 3px;
        }
    </style>
</head>

<body>fame
    <div class="container fame" style="background-color: #E5E5E5;">
        <div class="container row signup" style="background-color:  #FFFFFF;">
            <div>
                <form id="sign-up-form">
                    <div>
                        <h4>Create a free account</h4>
                    </div>
                    <div class="form-group">
                        <label for="input-name">Name</label>
                        <input type="name" class="form-control" id="input-name" placeholder="Your name">

                    </div>
                    <div class="form-group">
                        <label for="input-email">Email</label>
                        <input type="email" class="form-control" id="input-email" placeholder="Your email address">
                    </div>
                    <div class="form-group">
                        <label for="input-password">Password</label>
                        <input type="password" class="form-control" id="input-password" placeholder="Password">
                    </div>
                    <div class="form-group">
                        <label for="input-confirm-password">Confirm Password</label>
                        <input type="confirmPassword" class="form-control" id="input-confirm-password"
                            placeholder="Password">
                    </div>
                    <button type="sign-up" class="btn btn-success" onclick="onBtnSignUpClick()">Sign up</button>
                    <p class="text-center" style="font-size: 8px;">By signing up you agree to our <span
                            style="color: #38D39F;">Terms of Service</span> and <span style="color: #38D39F;">Privacy
                            Policy</span></p>
                    <p class="text-center" style="font-size: 12px;margin-top:57px;">Already have an account?<span
                            style="color: #38D39F;" ma>Login</span></p>

                </form>
            </div>
            <div><img src="imagem.png" alt=""></div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    function onBtnSignUpClick() {
        var vSignupForm = document.getElementById("sign-up-form");
        vSignupForm.addEventListener("submit", function (paramEvent) {
            // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
            paramEvent.preventDefault();
        });
        var vUserObj = {
            name: "",
            email: "",
            password: "",
            confirmPassword: "",
        }
        //B1 thu thập dữ liệu
        thuThapDuLieu(vUserObj);
        //B2 kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vUserObj);
        if (vDuLieuHopLe) {
            var vXmlHttpLogin = new XMLHttpRequest();
            //B3 gọi api login
            goiApiLogin(vUserObj, vXmlHttpLogin);
            vXmlHttpLogin.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vLoginInfo = vXmlHttpLogin.responseText;
                        //console.log(vLoginInfo);
                        var vLoginJsonObj = JSON.parse(vLoginInfo);

                         console.log(vLoginJsonObj);
                        if (vLoginJsonObj.length > 0) {
                            alert("Tạo tài khoảng thành công");
                        } else {
                            alert("Tạo tài khoảng thất bại")
                        }
                    }
                }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserObj) {
        var vInputName = document.getElementById("input-name");
        var vInputEmail = document.getElementById("input-email");
        var vInputPassword = document.getElementById("input-password");
        var vInputConfirmPassword = document.getElementById("input-confirm-password");
        paramUserObj.name = vInputName.value.trim();
        paramUserObj.email = vInputEmail.value.trim();
        paramUserObj.password = vInputPassword.value.trim();
        paramUserObj.confirmPassword = vInputConfirmPassword.value.trim();
    }
    function kiemTraDuLieu(paramUserObj) {
        if (paramUserObj.name == "") {
            alert("Bạn chưa nhập tên");
            return false;
        }
        var vRegexEmail = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (!paramUserObj.email.match(vRegexEmail)) {
            alert("Email không đúng định dạng");
            return false;
        }
        if (paramUserObj.password < 8) {
            alert("Mật khẩu phải lớn hơn hoặc bằng 8 kí tự");
            return false;
        }
        if (paramUserObj.password != paramUserObj.confirmPassword) {
            alert("Xác nhận mật khẩu không đúng");
            return false;
        }
        return true;
    }
    function goiApiLogin(paramUserObj, paramXmlHttp) {
        const vParams = new URLSearchParams({
            name: paramUserObj.name,
            email: paramUserObj.email,
            password: paramUserObj.password,
            confirmPassword: paramUserObj.confirmPassword
        });

        paramXmlHttp.open("GET", gBASE_URL + "?" + vParams.toString(), true);
        paramXmlHttp.send();
    }

</script>

</html>